######################################################################
#  Copyright (c) 2008-2013, Alliance for Sustainable Energy.
#  All rights reserved.
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
######################################################################

module EnergyPlus

  class IdfObject
    attr_accessor :type, :fields, :comment

    def initialize(object_type, object_fields, object_comment)
      @type = object_type
      @fields = object_fields
      @comment = object_comment
    end

    def fieldValue(fieldIdx)
      fieldValue = @fields[fieldIdx].split(',')
      fieldValue = fieldValue[0].split(';')[0].gsub(" ", "")

      return fieldValue.to_f

    end

    def fieldString(fieldIdx)
      fieldString = @fields[fieldIdx].split(',')
      fieldString = fieldString[0].split(';')[0].gsub(" ", "")

      return fieldString
    end


    def to_s
      string = ''
      string << @comment + "\n" if @comment
      string << @type + "\n"
      @fields.each { |field| string << field + "\n" }
      string << "\n"
    end
  end
end #module