######################################################################
#  Copyright (c) 2008-2013, Alliance for Sustainable Energy.
#  All rights reserved.
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
######################################################################

module EnergyPlus
  class IdfText
    def initialize(path)
      @path = path
      @lines = []
      if @path.exist?
        File.open(@path) do |f|
          while line = f.gets
            @lines << line.chomp
          end
        end
      end
    end

    def objects
      objects = []
      object_fields = []
      object_type = ''
      inobject = false
      object_comment = nil
      @lines.each_index do |i|
        if not inobject and @lines[i] =~ /^\s*\w/
          object_fields = []
          inobject = true
          object_type = @lines[i]
          if @lines[i-1] =~ /^\s*!/
            object_comment = @lines[i-1]
          end
        elsif inobject and @lines[i] =~ /^[^!]*;/
          object_fields << @lines[i]
          inobject = false
          objects << IdfObject.new(object_type,object_fields,object_comment)
        elsif inobject
          object_fields << @lines[i]
        else
        end
      end
      return objects
    end

    def findObjectByComment(comment)
      comment = Regexp.new(comment)
      objects().each do |object|
        if object.comment =~ comment
          return object
        end
      end
      return nil
    end
  end
end #module